

#include <stdafx.h>


#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <memory.h>




#include "wos.h"
#include "zip.h"
#include "etc.h"

#include "deb.h"



/*

  appinstall <filename>

  install contents of filename in applets folder


*/




static int level(char * name,int * dir)
{
 char * p;
 int    level;
 int    ch;
 int    lc;

cprintf("level %s",name);

 *dir=0;
 level=0;
 p=name;
 ch=lc=0;
 while(1)
 {
  lc=ch;
  ch=*p++;

  if(ch==0)
  {
   if(lc=='\\') *dir=1;
   break;
  }

  if(lc=='\\') level++;
 }

 return(level);
}



int main(int argc,char* argv[])
{
 os_error * err;
 char     * local;
 char       found[256];
 char       path[MAX_PATH];
 char     * start;
 int        n;
 int        dir;
 int        size;


	cprintf("Hello worlde");

 err=NULL;

 if(argc!=3)
 {
  err=generror(0,"syntax: appletinstall <application name> <applet file name>");
 }

 if(!err)
 {
  sprintf(found,"HKLM\\Software\\DavidPilling\\%s\\Applets",argv[1]);
  size=sizeof(path);

           err=regreadstr(found,path,&size);

		cprintf("load %s",path);

  if(!err)	err=ziploadfile(argv[2]);
  if(!err)
  {
   start=NULL;
   local=zipseek("install.txt",start,found,&start);
   if(local) err=generror(0,"Applet is too new for installation program");
   if(!err)
   {
    start=NULL;
    while(1)
    {
     local=zipseek(NULL,start,found,&start);

     cprintf("local %x",local);

     if(!local) break;
     n=level(found,&dir);

    	cprintf("level %d\r\n",n);

//     if(n==0)
     {
      err=zipwritefile(found,path,local);
      if(err) break;
     }
    }
   }
  }
 }


 if(err) MessageBox((HWND)NULL,err->errmess,argv[1],MB_OK | MB_ICONERROR);
 else    MessageBox((HWND)NULL,"Applet installed.",argv[1],MB_ICONINFORMATION);

	return(0);
}



int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{

 return(main(__argc,__argv));

 USE(hInstance);
 USE(nCmdShow);
 USE(lpCmdLine);
 USE(hPrevInstance);
}
