// Twain.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"

#include "transform.h"

#include "xprocess.h"



#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "sp.h"
#include "task.h"
#include "xhelp.h"
#include "trans.h"
#include "dbhi.h"
#include "key.h"
#include "temp.h"

#include "xext.h"



#include "constants.h"
#include "str.h"


#include "file.h"
#include "view.h"
#include "viewo.h"


#include "units.h"

#include "object.h"
#include "select.h"

#include "dbscale.h"



#include "tw.h"







static HANDLE modulehandle;

static char * twainpath;






void twain_select(void)
{

 zreport(twainselect());

}



void twain_acquire(void)
{

 zreport(twainacquire());


}






#define XFNS 3         


static fndefn fntable[XFNS]=
{


 "twain_select",(extfn)twain_select,"",PVOID,0,
 "twain_acquire",(extfn)twain_acquire,"",PVOID,0,

 NULL,NULL,NULL,0,0
};


static xfnlink fnlink;


static os_error * scriptevent(int eventn,int userhandle,
                                                    void * data,int data1)
{
 remevent(EVENT_SCRIPTINIT,scriptevent,0);
 return(addsymboltable(fntable,&fnlink));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}





extern "C" __declspec(dllexport) os_error * entrypoint(char * path)
{ 
 os_error * err;

 twainpath=path;

 err=addevent(EVENT_SCRIPTINIT,scriptevent,0);
 if(!err) err=twaininit();

 return(err);
}





extern "C" BOOL __stdcall _DllMainCRTStartup( 
    HINSTANCE hinstDLL,     // handle to DLL module 
    DWORD fdwReason,        // reason for calling function 
    LPVOID lpvReserved)     // reserved 
{
 
 modulehandle=(HMODULE)hinstDLL;
 return(TRUE);
}



