


int hints_oneshot;
int hints_start;
int hints_number;
int hints_total;



int hin_tag=('h'<<24)|('i'<<16)|('n'<<8);

// read choices

void hints_readchoices(void)
{
 if(tagexists(0,hin_tag,0))
 {
  hints_number=tagread(0,hin_tag,0);
  hints_start=tagread(0,hin_tag,1);
 }
 else
 {
  hints_number=1;
  hints_start=1;
 }
}


// write choices

void hints_quit(int user)
{
 tagwrite(0,hin_tag,hints_number,0);
 tagwrite(0,hin_tag,hints_start,1);
}



// display the next hint

void hints_message(int hints_handle)
{
 string s;

 if(++hints_number>hints_total)
  hints_number = 1;
 s = "{HINTS_" + itos(hints_number) + "}";
 translate(s);
 writeicon(hints_handle, 0, "");;
 refresh_icon(0, hints_handle, 0);
 writeicon(hints_handle, 0, s);;
}



// handler for hints window close icon

void hints_closebox(int handle)
{
 close_window(handle);
 delete_window(handle);
}




int hints_keypress(int handle,int icon,int key)
{
 if(key==13 || key==27)
 {
  hints_closebox(handle);
  return(-1);
 }
 return(key);
}





void hints_open(int view)
{
 int hints_handle;

 hints_handle=create_windowparent("hints_main",viewhandle(view));

 addwindowhandler(0,hints_handle,"hints_clicknext");
 addwindowhandler(2,hints_handle,"hints_closebox");
 addwindowhandler(7,hints_handle,"hints_closebox");
 addwindowhandler(1,hints_handle,"hints_keypress");

 select_icon(hints_handle,5,hints_start);
 display_window(hints_handle,0,1);
 hints_message(hints_handle);
 setactive(hints_handle);
}


void hints_openview(int user, int view)
{
 if(hints_oneshot==0 && hints_start)
 {
  hints_oneshot=1;
  hints_open(view);
 }
}



// deal with 'Hints' menu entry

int hints_entry(int entry, int subcode)
{
 hints_open(currentview());
 return(0);
}



// handler for mouse clicks in hints box

void hints_clicknext(int handle,int icon,int bits,int mx,int my)
{
 if(icon==4) hints_message(handle);
 if(icon==5) hints_start=!hints_start;
}




// create 'Hints' window, read max number of hints and display hint

void main(void)
{
 string s;

 script_menu_initialise();


 script_menu_insert("hints_entry","","","","{HINTS_00}");

 addeventhandler(0x004,0,"hints_quit");
 addeventhandler(0x214,0,"hints_openview");

 s = "{HINTS_TOTAL}";
 translate(s);
 hints_total = stoi(s);

 hints_readchoices();
}
