// rdsp.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


#include <stdlib.h>
#include <string.h>

#include <windows.h>





const int tilex=8;
const int tiley=8;

const int arrayx=9;
const int arrayy=9;

const int slicex=9;
const int slicey=9;



const int sasize=16;
const int shdrsize=11*4;





static char * fs_strcat(char * path,char * filename)
{
 char * p;

 p=path+strlen(path);
 if(p>path && *(p-1)=='\\')
 {

 }
 else
 {
  *p++='\\';
 }

 strcpy(p,filename);

 return(path);
}




static char * fs_leaf(char * filename)
{
 char * p;

        p=strrchr(filename,'\\');
 if(!p) p=strrchr(filename,'/');
 if(!p)
 {
  p=strrchr(filename,':');
  if(!p) p=filename;
  else   p+=1;
 } else  p+=1;
 return(p);
}








static int gettile(int ay,int ax,int ty,int tx,char * p,int xpix)
{
 p+=sasize+shdrsize;
 p+=((tilex/2+tx*tilex+ax*(arrayx+1)*tilex)*4);
 p+=((tiley/2+ty*tiley+ay*(arrayy+1)*tiley)*xpix*4);

 return(*(int*)p);
}



static char * loadsprite(char * filename,int xpix,int ypix)
{
 FILE * fp;
 int    sdatasize=xpix*ypix*4;
 int    ssize=sasize+shdrsize+sdatasize;
 char * p;
 int    i;

 p=(char*)malloc(ssize);

 for(i=0;i<ssize;i+=4)
 {
  *(int*)(p+i)=0xFFFFFF;
 }


 fp=fopen(filename,"rb");
 if(fp)
 {
  fread(p+4,ssize-4,1,fp);
  fclose(fp);
 }

 return(p);
}






int main(int argc, char* argv[])
{
 char * p;
 char * q;
 char   path[MAX_PATH];
 int    xpix;
 int    ypix;
 int    c;
 int    m;
 int    y;
 int    k;
 int    C;
 int    M;
 int    Y;
 int    K;
 FILE * fp;
 int    b;

 
 xpix=(arrayx+1)*tilex*slicex;
 ypix=(arrayy+1)*tiley*slicey;


 strcpy(path,argv[0]);
 q=fs_leaf(path);
 *q=0;
 fs_strcat(path,"rgb.spr");

 p=loadsprite(path,xpix,ypix);

 q=fs_leaf(path);
 *q=0;
 fs_strcat(path,"NewTable.dat");

 fp=fopen(path,"wb+");
 if(fp)
 {
// x%=OPENOUT("<OvationPro$Dir>.Applets.!ColSupp.Resources.Tables.NewTable")

  k=0;
  for(K=0;K<slicey;K++)
  {
   m=0;
   for(M=0;M<slicex;M++)
   {
    c=0;
    for(C=0;C<arrayy;C++)
    {
     y=0;
     for(Y=0;Y<arrayx;Y++)
     {
      b=gettile(K,M,C,Y,p,xpix);

      fputc((b & 0xFF),fp);
      fputc(((b>>8) & 0xFF),fp);
      fputc(((b>>16) & 0xFF),fp);
      fputc(((b>>24) & 0xFF),fp);
 
      if(y==0) y=31; else y+=32;
     }
     if(c==0) c=31; else c+=32;
    }
    if(m==0) m=31; else m+=32;
   }
   if(k==0) k=31; else k+=32;
  }
  fclose(fp);
 }
	return 0;
}

